]> git.saurik.com Git - apt.git/blob - test/integration/framework
select kernels to protect from autoremove based on Debian version
[apt.git] / test / integration / framework
1 #!/bin/sh -- # no runable script, just for vi
2
3 EXIT_CODE=0
4
5 while [ -n "$1" ]; do
6 if [ "$1" = "-q" ]; then
7 export MSGLEVEL=2
8 elif [ "$1" = "-v" ]; then
9 export MSGLEVEL=4
10 elif [ "$1" = '--color=no' ]; then
11 export MSGCOLOR='NO'
12 else
13 echo >&2 "WARNING: Unknown parameter »$1« will be ignored"
14 fi
15 shift
16 done
17 export MSGLEVEL="${MSGLEVEL:-3}"
18
19 # we all like colorful messages
20 if [ "$MSGCOLOR" != 'NO' ] && [ "$MSGCOLOR" != 'ALWAYS' ]; then
21 if [ ! -t 1 ]; then # but check that we output to a terminal
22 export MSGCOLOR='NO'
23 fi
24 fi
25
26
27 if [ "$MSGCOLOR" != 'NO' ]; then
28 CERROR="\033[1;31m" # red
29 CWARNING="\033[1;33m" # yellow
30 CMSG="\033[1;32m" # green
31 CINFO="\033[1;96m" # light blue
32 CDEBUG="\033[1;94m" # blue
33 CNORMAL="\033[0;39m" # default system console color
34 CDONE="\033[1;32m" # green
35 CPASS="\033[1;32m" # green
36 CFAIL="\033[1;31m" # red
37 CCMD="\033[1;35m" # pink
38 fi
39
40 msgprintf() {
41 local START="$1"
42 local MIDDLE="$2"
43 local END="$3"
44 shift 3
45 if [ -n "$1" ]; then
46 printf "$START " "$1"
47 shift
48 while [ -n "$1" ]; do
49 printf "$MIDDLE " "$(echo "$1" | sed -e 's#^apt\([cfghs]\)#apt-\1#')"
50 shift
51 done
52 fi
53 printf "${END}"
54 }
55 msgdie() { msgprintf "${CERROR}E: %s" '%s' "${CNORMAL}\n" "$@" >&2; exit 1; }
56 msgwarn() { msgprintf "${CWARNING}W: %s" '%s' "${CNORMAL}\n" "$@" >&2; }
57 msgmsg() { msgprintf "${CMSG}%s" '%s' "${CNORMAL}\n" "$@"; }
58 msginfo() { msgprintf "${CINFO}I: %s" '%s' "${CNORMAL}\n" "$@"; }
59 msgdebug() { msgprintf "${CDEBUG}D: %s" '%s' "${CNORMAL}\n" "$@"; }
60 msgdone() { msgprintf "${CDONE}DONE" '%s' "${CNORMAL}\n" "$@"; }
61 msgnwarn() { msgprintf "${CWARNING}W: %s" '%s' "${CNORMAL}" "$@" >&2; }
62 msgnmsg() { msgprintf "${CMSG}%s" '%s' "${CNORMAL}" "$@"; }
63 msgninfo() { msgprintf "${CINFO}I: %s" '%s' "${CNORMAL}" "$@"; }
64 msgndebug() { msgprintf "${CDEBUG}D: %s" '%s' "${CNORMAL}" "$@"; }
65 msgtest() { msgprintf "${CINFO}%s" "${CCMD}%s${CINFO}" "…${CNORMAL} " "$@"; }
66 msgpass() { printf "${CPASS}PASS${CNORMAL}\n"; }
67 msgreportheader() {
68 if [ -n "$MSGTEST_MSG" ]; then
69 test "$1" != 'msgfailoutput' || echo
70 if [ -n "$MSGTEST_MSGMSG" ]; then
71 echo "$MSGTEST_MSGMSG"
72 fi
73 if [ -n "$MSGTEST_GRP" ] && [ "$MSGTEST_GRP" != 'NEXT' ] && [ "$MSGTEST_GRP" != "$MSGTEST_MSG" ]; then
74 echo "${CFAIL}Part of the test group: $MSGTEST_GRP"
75 fi
76 echo -n "$MSGTEST_MSG"
77 unset MSGTEST_MSG
78 fi
79 }
80 msgskip() {
81 msgreportheader 'msgskip'
82 if [ $# -gt 0 ]; then printf "${CWARNING}SKIP: $*${CNORMAL}\n" >&2;
83 else printf "${CWARNING}SKIP${CNORMAL}\n" >&2; fi
84 }
85 msgfail() {
86 msgreportheader 'msgfail'
87 if [ $# -gt 0 ] && [ -n "$1" ]; then printf "${CFAIL}FAIL: $*${CNORMAL}\n" >&2;
88 else printf "${CFAIL}FAIL${CNORMAL}\n" >&2; fi
89 if [ -n "$APT_DEBUG_TESTS" ]; then
90 $SHELL
91 fi
92 EXIT_CODE=$((EXIT_CODE+1));
93 }
94 MSGGROUP_LEVEL=0
95 msggroup() {
96 if [ -n "$1" ]; then
97 if [ $MSGGROUP_LEVEL = 0 ]; then
98 MSGTEST_GRP='NEXT'
99 fi
100 MSGGROUP_LEVEL=$((MSGGROUP_LEVEL+1));
101 else
102 MSGGROUP_LEVEL=$((MSGGROUP_LEVEL-1));
103 if [ $MSGGROUP_LEVEL = 0 ]; then
104 unset MSGTEST_GRP
105 fi
106 fi
107 }
108
109 # enable / disable Debugging
110 if [ $MSGLEVEL -le 0 ]; then
111 msgdie() { true; }
112 fi
113 if [ $MSGLEVEL -le 1 ]; then
114 msgwarn() { true; }
115 msgnwarn() { true; }
116 fi
117 if [ $MSGLEVEL -le 2 ]; then
118 msgmsg() {
119 MSGTEST_MSGMSG="$(msgprintf "${CMSG}%s" '%s' "${CNORMAL}" "$@")"
120 }
121 msgnmsg() { true; }
122 msgtest() {
123 MSGTEST_MSG="$(msgprintf "${CINFO}%s" "${CCMD}%s${CINFO}" "…${CNORMAL} " "$@")"
124 if [ "$MSGTEST_GRP" = 'NEXT' ]; then
125 MSGTEST_GRP="$MSGTEST_MSG"
126 fi
127 }
128 msgpass() { printf " ${CPASS}P${CNORMAL}"; }
129 fi
130 if [ $MSGLEVEL -le 3 ]; then
131 msginfo() { true; }
132 msgninfo() { true; }
133 fi
134 if [ $MSGLEVEL -le 4 ]; then
135 msgdebug() { true; }
136 msgndebug() { true; }
137 fi
138 msgdone() {
139 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
140 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
141 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
142 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
143 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
144 true;
145 else
146 printf "${CDONE}DONE${CNORMAL}\n";
147 fi
148 }
149 getaptconfig() {
150 if [ -f ./aptconfig.conf ]; then
151 echo "$(readlink -f ./aptconfig.conf)"
152 elif [ -f ../aptconfig.conf ]; then
153 echo "$(readlink -f ../aptconfig.conf)"
154 elif [ -f ../../aptconfig.conf ]; then
155 echo "$(readlink -f ../../aptconfig.conf)"
156 elif [ -f "${TMPWORKINGDIRECTORY}/aptconfig.conf" ]; then
157 echo "$(readlink -f "${TMPWORKINGDIRECTORY}/aptconfig.conf")"
158 fi
159 }
160 runapt() {
161 msgdebug "Executing: ${CCMD}$*${CDEBUG} "
162 local CMD="$1"
163 shift
164 case $CMD in
165 sh|aptitude|*/*|command) ;;
166 *) CMD="${BUILDDIRECTORY}/$CMD";;
167 esac
168 MALLOC_PERTURB_=21 MALLOC_CHECK_=2 APT_CONFIG="$(getaptconfig)" LD_LIBRARY_PATH=${LIBRARYPATH} $CMD "$@"
169 }
170 aptconfig() { runapt apt-config "$@"; }
171 aptcache() { runapt apt-cache "$@"; }
172 aptcdrom() { runapt apt-cdrom "$@"; }
173 aptget() { runapt apt-get "$@"; }
174 aptftparchive() { runapt apt-ftparchive "$@"; }
175 aptkey() { runapt apt-key "$@"; }
176 aptmark() { runapt apt-mark "$@"; }
177 aptsortpkgs() { runapt apt-sortpkgs "$@"; }
178 apt() { runapt apt "$@"; }
179 apthelper() { runapt "${APTHELPERBINDIR}/apt-helper" "$@"; }
180 aptwebserver() { runapt "${APTWEBSERVERBINDIR}/aptwebserver" "$@"; }
181 aptitude() { runapt aptitude "$@"; }
182 aptextracttemplates() { runapt apt-extracttemplates "$@"; }
183 aptinternalsolver() { runapt "${APTINTERNALSOLVER}" "$@"; }
184 aptdumpsolver() { runapt "${APTDUMPSOLVER}" "$@"; }
185
186 dpkg() {
187 "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" "$@"
188 }
189 dpkgcheckbuilddeps() {
190 command dpkg-checkbuilddeps --admindir=${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg "$@"
191 }
192 gdb() {
193 local CMD
194 case "$1" in
195 aptget) CMD="apt-get";;
196 aptcache) CMD="apt-cache";;
197 aptcdrom) CMD="apt-cdrom";;
198 aptconfig) CMD="apt-config";;
199 aptmark) CMD="apt-mark";;
200 apthelper) CMD="apt-helper";;
201 aptftparchive) CMD="apt-ftparchive";;
202 dpkg) shift; runapt ${TMPWORKINGDIRECTORY}/rootdir/usr/bin/gdb-dpkg "$@"; return;;
203 *) CMD="$1";;
204 esac
205 shift
206 if [ "${CMD##*/}" = "$CMD" ]; then
207 CMD="${BUILDDIRECTORY}/${CMD}"
208 fi
209 runapt command gdb --quiet -ex run "$CMD" --args "$CMD" "$@"
210 }
211
212 exitwithstatus() {
213 # error if we about to overflow, but ...
214 # "255 failures ought to be enough for everybody"
215 if [ $EXIT_CODE -gt 255 ]; then
216 msgdie "Total failure count $EXIT_CODE too big"
217 fi
218 exit $((EXIT_CODE <= 255 ? EXIT_CODE : 255));
219 }
220
221 shellsetedetector() {
222 local exit_status=$?
223 if [ "$exit_status" != '0' ]; then
224 printf >&2 "${CERROR}E: Looks like the testcases ended prematurely with exitcode: ${exit_status}${CNORMAL}\n"
225 if [ "$EXIT_CODE" = '0' ]; then
226 EXIT_CODE="$exit_status"
227 fi
228 fi
229 }
230
231 addtrap() {
232 if [ "$1" = 'prefix' ]; then
233 CURRENTTRAP="$2 $CURRENTTRAP"
234 else
235 CURRENTTRAP="$CURRENTTRAP $1"
236 fi
237 trap "shellsetedetector; $CURRENTTRAP exitwithstatus;" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
238 }
239
240 setupenvironment() {
241 # privilege dropping and testing doesn't work if /tmp isn't world-writeable (as e.g. with libpam-tmpdir)
242 if [ -n "$TMPDIR" ] && [ "$(id -u)" = '0' ] && [ "$(stat --format '%a' "$TMPDIR")" != '1777' ]; then
243 unset TMPDIR
244 fi
245 TMPWORKINGDIRECTORY=$(mktemp -d)
246 addtrap "cd /; rm -rf $TMPWORKINGDIRECTORY;"
247 msgninfo "Preparing environment for $(basename $0) in ${TMPWORKINGDIRECTORY}…"
248
249 mkdir -m 700 "${TMPWORKINGDIRECTORY}/downloaded"
250 if [ "$(id -u)" = '0' ]; then
251 # relax permissions so that running as root with user switching works
252 umask 022
253 chmod 711 "$TMPWORKINGDIRECTORY"
254 chown _apt:root "${TMPWORKINGDIRECTORY}/downloaded"
255 fi
256
257 TESTDIRECTORY=$(readlink -f $(dirname $0))
258 # allow overriding the default BUILDDIR location
259 SOURCEDIRECTORY=${APT_INTEGRATION_TESTS_SOURCE_DIR:-"${TESTDIRECTORY}/../../"}
260 BUILDDIRECTORY=${APT_INTEGRATION_TESTS_BUILD_DIR:-"${TESTDIRECTORY}/../../build/bin"}
261 LIBRARYPATH=${APT_INTEGRATION_TESTS_LIBRARY_PATH:-"${BUILDDIRECTORY}"}
262 METHODSDIR=${APT_INTEGRATION_TESTS_METHODS_DIR:-"${BUILDDIRECTORY}/methods"}
263 APTHELPERBINDIR=${APT_INTEGRATION_TESTS_LIBEXEC_DIR:-"${BUILDDIRECTORY}"}
264 APTWEBSERVERBINDIR=${APT_INTEGRATION_TESTS_WEBSERVER_BIN_DIR:-"${BUILDDIRECTORY}"}
265 APTINTERNALSOLVER=${APT_INTEGRATION_TESTS_INTERNAL_SOLVER:-"${BUILDDIRECTORY}/apt-internal-solver"}
266 APTDUMPSOLVER=${APT_INTEGRATION_TESTS_DUMP_SOLVER:-"${BUILDDIRECTORY}/apt-dump-solver"}
267 test -x "${BUILDDIRECTORY}/apt-get" || msgdie "You need to build tree first"
268 # -----
269
270 cd $TMPWORKINGDIRECTORY
271 mkdir rootdir aptarchive keys
272 cd rootdir
273 mkdir -p etc/apt/apt.conf.d etc/apt/sources.list.d etc/apt/trusted.gpg.d etc/apt/preferences.d
274 mkdir -p usr/bin var/cache var/lib var/log tmp
275 mkdir -p var/lib/dpkg/info var/lib/dpkg/updates var/lib/dpkg/triggers
276 touch var/lib/dpkg/available
277 mkdir -p usr/lib/apt
278 ln -s ${METHODSDIR} usr/lib/apt/methods
279 if [ "$BUILDDIRECTORY" = "$LIBRARYPATH" ]; then
280 mkdir -p usr/lib/apt/solvers
281 ln -s "${BUILDDIRECTORY}/apt-dump-solver" usr/lib/apt/solvers/dump
282 ln -s "${BUILDDIRECTORY}/apt-internal-solver" usr/lib/apt/solvers/apt
283 echo "Dir::Bin::Solvers \"${TMPWORKINGDIRECTORY}/rootdir/usr/lib/apt/solvers\";" > etc/apt/apt.conf.d/externalsolver.conf
284 fi
285 # use the autoremove from the BUILDDIRECTORY if its there, otherwise
286 # system
287 if [ -e ${BUILDDIRECTORY}/../../debian/apt.conf.autoremove ]; then
288 ln -s ${BUILDDIRECTORY}/../../debian/apt.conf.autoremove etc/apt/apt.conf.d/01autoremove
289 else
290 ln -s /etc/apt/apt.conf.d/01autoremove etc/apt/apt.conf.d/01autoremove
291 fi
292 cd ..
293 local PACKAGESFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
294 if [ -f "${TESTDIRECTORY}/${PACKAGESFILE}" ]; then
295 cp "${TESTDIRECTORY}/${PACKAGESFILE}" aptarchive/Packages
296 fi
297 local SOURCESSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Sources-/' -e 's/^skip-/Sources-/')
298 if [ -f "${TESTDIRECTORY}/${SOURCESSFILE}" ]; then
299 cp "${TESTDIRECTORY}/${SOURCESSFILE}" aptarchive/Sources
300 fi
301 cp $(find $TESTDIRECTORY -name '*.pub' -o -name '*.sec') keys/
302 chmod 644 $(find keys -name '*.pub' -o -name '*.sec')
303 ln -s ${TMPWORKINGDIRECTORY}/keys/joesixpack.pub rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg
304
305 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
306 echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
307 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
308 echo "Dir::Bin::Methods \"${TMPWORKINGDIRECTORY}/rootdir/usr/lib/apt/methods\";" >> aptconfig.conf
309 # store apt-key were we can access it, even if we run it as a different user
310 # destroys coverage reporting though, so just do it for root for now
311 if [ "$(id -u)" = '0' ]; then
312 cp "${BUILDDIRECTORY}/apt-key" "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/"
313 chmod o+rx "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/apt-key"
314 echo "Dir::Bin::apt-key \"${TMPWORKINGDIRECTORY}/rootdir/usr/bin/apt-key\";" >> aptconfig.conf
315 else
316 echo "Dir::Bin::apt-key \"${BUILDDIRECTORY}/apt-key\";" >> aptconfig.conf
317 fi
318
319 cat << EOF > "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg"
320 #!/bin/sh
321 set -e
322 if [ -r "${TMPWORKINGDIRECTORY}/noopchroot.so" ]; then
323 if [ -n "\$LD_PRELOAD" ]; then
324 export LD_PRELOAD="${TMPWORKINGDIRECTORY}/noopchroot.so \${LD_PRELOAD}"
325 else
326 export LD_PRELOAD="${TMPWORKINGDIRECTORY}/noopchroot.so"
327 fi
328 fi
329 exec fakeroot ${DPKG:-dpkg} --root="${TMPWORKINGDIRECTORY}/rootdir" \\
330 --log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log \\
331 --force-not-root --force-bad-path "\$@"
332 EOF
333 cat << EOF > "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/gdb-dpkg"
334 #!/bin/sh
335 set -e
336 if [ -r "${TMPWORKINGDIRECTORY}/noopchroot.so" ]; then
337 if [ -n "\$LD_PRELOAD" ]; then
338 export LD_PRELOAD="${TMPWORKINGDIRECTORY}/noopchroot.so \${LD_PRELOAD}"
339 else
340 export LD_PRELOAD="${TMPWORKINGDIRECTORY}/noopchroot.so"
341 fi
342 fi
343 exec fakeroot gdb --quiet -ex run "${DPKG:-dpkg}" --args "${DPKG:-dpkg}" --root="${TMPWORKINGDIRECTORY}/rootdir" \\
344 --log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log \\
345 --force-not-root --force-bad-path "\$@"
346 EOF
347 chmod +x "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/gdb-dpkg"
348 echo "Dir::Bin::dpkg \"${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg\";" > rootdir/etc/apt/apt.conf.d/99dpkg
349
350 {
351 if ! command dpkg --assert-multi-arch >/dev/null 2>&1; then
352 echo "DPKG::options:: \"--force-architecture\";" # Added to test multiarch before dpkg is ready for it…
353 fi
354 echo 'quiet::NoUpdate "true";'
355 echo 'quiet::NoStatistic "true";'
356 # too distracting for users, but helpful to detect changes
357 echo 'Acquire::Progress::Ignore::ShowErrorText "true";'
358 echo 'Acquire::Progress::Diffpercent "true";'
359 # in testcases, it can appear as if localhost has a rotation setup,
360 # hide this as we can't really deal with it properly
361 echo 'Acquire::Failure::ShowIP "false";'
362 } >> aptconfig.conf
363
364 cp "${TESTDIRECTORY}/apt.pem" "${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem"
365 if [ "$(id -u)" = '0' ]; then
366 chown _apt:root "${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem"
367 fi
368 echo "Acquire::https::CaInfo \"${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem\";" > rootdir/etc/apt/apt.conf.d/99https
369 echo "Apt::Cmd::Disable-Script-Warning \"1\";" > rootdir/etc/apt/apt.conf.d/apt-binary
370 configcompression '.' 'gz' #'bz2' 'lzma' 'xz'
371
372 # create some files in /tmp and look at user/group to get what this means
373 TEST_DEFAULT_USER="$USER"
374 if [ "$(uname)" = 'GNU/kFreeBSD' ]; then
375 TEST_DEFAULT_GROUP='root'
376 else
377 TEST_DEFAULT_GROUP="$USER"
378 fi
379
380 # Acquire::AllowInsecureRepositories=false is not yet the default
381 # but we want it to be the default soon
382 configallowinsecurerepositories "false";
383
384 # cleanup the environment a bit
385 # prefer our apt binaries over the system apt binaries
386 export PATH="${BUILDDIRECTORY}:${PATH}:/usr/local/sbin:/usr/sbin:/sbin"
387 export LC_ALL=C.UTF-8
388 unset LANGUAGE APT_CONFIG
389 unset GREP_OPTIONS DEB_BUILD_PROFILES
390 msgdone "info"
391 }
392
393 getarchitecture() {
394 if [ "$1" = "native" -o -z "$1" ]; then
395 eval `aptconfig shell ARCH APT::Architecture`
396 if [ -n "$ARCH" ]; then
397 echo $ARCH
398 else
399 dpkg --print-architecture
400 fi
401 else
402 echo $1
403 fi
404 }
405
406 getarchitectures() {
407 aptconfig dump --no-empty --format '%v%n' APT::Architecture APT::Architectures | sort -u | tr '\n' ' '
408 }
409
410 getarchitecturesfromcommalist() {
411 echo "$1" | sed -e 's#,#\n#g' | sed -e "s/^native\$/$(getarchitecture 'native')/"
412 }
413
414 configarchitecture() {
415 {
416 echo "APT::Architecture \"$(getarchitecture $1)\";"
417 while [ -n "$1" ]; do
418 echo "APT::Architectures:: \"$(getarchitecture $1)\";"
419 shift
420 done
421 } >rootdir/etc/apt/apt.conf.d/01multiarch.conf
422 configdpkg
423 }
424
425 configdpkg() {
426 if [ ! -e rootdir/var/lib/dpkg/status ]; then
427 local STATUSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
428 if [ -f "${TESTDIRECTORY}/${STATUSFILE}" ]; then
429 cp "${TESTDIRECTORY}/${STATUSFILE}" rootdir/var/lib/dpkg/status
430 else
431 echo -n > rootdir/var/lib/dpkg/status
432 fi
433 fi
434 rm -f rootdir/etc/apt/apt.conf.d/00foreigndpkg
435 if command dpkg --assert-multi-arch >/dev/null 2>&1 ; then
436 local ARCHS="$(getarchitectures)"
437 if echo "$ARCHS" | grep -E -q '[^ ]+ [^ ]+'; then
438 DPKGARCH="$(dpkg --print-architecture)"
439 for ARCH in ${ARCHS}; do
440 if [ "${ARCH}" != "${DPKGARCH}" ]; then
441 if ! dpkg --add-architecture ${ARCH} >/dev/null 2>&1; then
442 # old-style used e.g. in Ubuntu-P – and as it seems travis
443 echo "DPKG::options:: \"--foreign-architecture\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg
444 echo "DPKG::options:: \"${ARCH}\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg
445 fi
446 fi
447 done
448 if [ "0" = "$(dpkg -l dpkg 2> /dev/null | grep '^i' | wc -l)" ]; then
449 # dpkg doesn't really check the version as long as it is fully installed,
450 # but just to be sure we choose one above the required version
451 insertinstalledpackage 'dpkg' "all" '1.16.2+fake'
452 fi
453 fi
454 fi
455 }
456
457 configdpkgnoopchroot() {
458 # create a library to noop chroot() and rewrite maintainer script executions
459 # via execvp() as used by dpkg as we don't want our rootdir to be a fullblown
460 # chroot directory dpkg could chroot into to execute the maintainer scripts
461 msgtest 'Building library to preload to make maintainerscript work in' 'dpkg'
462 cat << EOF > noopchroot.c
463 #define _GNU_SOURCE
464 #include <stdio.h>
465 #include <stdlib.h>
466 #include <string.h>
467 #include <dlfcn.h>
468
469 static char * chrootdir = NULL;
470
471 int chroot(const char *path) {
472 printf("WARNING: CHROOTing to %s was ignored!\n", path);
473 free(chrootdir);
474 chrootdir = strdup(path);
475 return 0;
476 }
477 int execvp(const char *file, char *const argv[]) {
478 static int (*func_execvp) (const char *, char * const []) = NULL;
479 if (func_execvp == NULL)
480 func_execvp = (int (*) (const char *, char * const [])) dlsym(RTLD_NEXT, "execvp");
481 if (chrootdir == NULL || strncmp(file, "/var/lib/dpkg/", strlen("/var/lib/dpkg/")) != 0)
482 return func_execvp(file, argv);
483 printf("REWRITE execvp call %s into %s\n", file, chrootdir);
484 char newfile[strlen(chrootdir) + strlen(file)];
485 strcpy(newfile, chrootdir);
486 strcat(newfile, file);
487 char const * const baseadmindir = "/var/lib/dpkg";
488 char admindir[strlen(chrootdir) + strlen(baseadmindir)];
489 strcpy(admindir, chrootdir);
490 strcat(admindir, baseadmindir);
491 setenv("DPKG_ADMINDIR", admindir, 1);
492 return func_execvp(newfile, argv);
493 }
494 EOF
495 testsuccess --nomsg gcc -fPIC -shared -o noopchroot.so noopchroot.c -ldl
496 }
497
498 configallowinsecurerepositories() {
499 echo "Acquire::AllowInsecureRepositories \"$1\";" > rootdir/etc/apt/apt.conf.d/allow-insecure-repositories.conf
500
501 }
502
503 configcompression() {
504 while [ -n "$1" ]; do
505 case "$1" in
506 '.') printf ".\t.\tcat\n";;
507 'gz') printf "gzip\tgz\tgzip\n";;
508 'bz2') printf "bzip2\tbz2\tbzip2\n";;
509 'lzma') printf "lzma\tlzma\txz --format=lzma\n";;
510 'xz') printf "xz\txz\txz\n";;
511 *) printf "$1\t$1\t$1\n";;
512 esac
513 shift
514 done > ${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf
515 }
516
517 forcecompressor() {
518 COMPRESSOR="$1"
519 COMPRESSOR_CMD="$1"
520 case $COMPRESSOR in
521 gzip) COMPRESS='gz';;
522 bzip2) COMPRESS='bz2';;
523 lzma) COMPRESS='lzma';;
524 xz) COMPRESS='xz';;
525 *) msgdie "Compressor $COMPRESSOR is unknown to framework, so can't be forced by forcecompressor!";;
526 esac
527 local CONFFILE="${TMPWORKINGDIRECTORY}/rootdir/etc/apt/apt.conf.d/00force-compressor"
528 echo "Acquire::CompressionTypes::Order { \"${COMPRESS}\"; };
529 Dir::Bin::uncompressed \"/does/not/exist\";
530 Dir::Bin::gzip \"/does/not/exist\";
531 Dir::Bin::bzip2 \"/does/not/exist\";
532 Dir::Bin::lzma \"/does/not/exist\";
533 Dir::Bin::xz \"/does/not/exist\";" > "$CONFFILE"
534 if [ -e "/bin/${COMPRESSOR}" ]; then
535 echo "Dir::Bin::${COMPRESSOR} \"/bin/${COMPRESSOR}\";" >> "$CONFFILE"
536 elif [ -e "/usr/bin/${COMPRESSOR}" ]; then
537 echo "Dir::Bin::${COMPRESSOR} \"/usr/bin/${COMPRESSOR}\";" >> "$CONFFILE"
538 elif [ "${COMPRESSOR}" = 'lzma' ]; then
539 echo 'Dir::Bin::xz "/usr/bin/xz";' >> "$CONFFILE"
540 COMPRESSOR_CMD='xz --format=lzma'
541 else
542 msgtest 'Test for availability of compressor' "${COMPRESSOR}"
543 msgfail "${COMPRESSOR} not available"
544 fi
545 }
546
547 setupsimplenativepackage() {
548 local NAME="$1"
549 local ARCH="$2"
550 local VERSION="$3"
551 local RELEASE="${4:-unstable}"
552 local DEPENDENCIES="$5"
553 local DESCRIPTION="${6:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
554 If you find such a package installed on your system,
555 something went horribly wrong! They are autogenerated
556 und used only by testcases and surf no other propose…"}"
557
558 local SECTION="${7:-others}"
559 local DISTSECTION
560 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
561 DISTSECTION="main"
562 else
563 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
564 fi
565 local BUILDDIR=incoming/${NAME}-${VERSION}
566 mkdir -p ${BUILDDIR}/debian/source
567 cd ${BUILDDIR}
568 echo "* most suckless software product ever" > FEATURES
569 test -e debian/copyright || echo "Copyleft by Joe Sixpack $(date +%Y)" > debian/copyright
570 test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency=low
571
572 * Initial release
573
574 -- Joe Sixpack <joe@example.org> $(date -R)" > debian/changelog
575 test -e debian/control || echo "Source: $NAME
576 Section: $SECTION
577 Priority: optional
578 Maintainer: Joe Sixpack <joe@example.org>
579 Build-Depends: debhelper (>= 7)
580 Standards-Version: 3.9.1
581
582 Package: $NAME" > debian/control
583 if [ "$ARCH" = 'all' ]; then
584 echo "Architecture: all" >> debian/control
585 else
586 echo "Architecture: any" >> debian/control
587 fi
588 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
589 echo "Description: $DESCRIPTION" >> debian/control
590
591 test -e debian/compat || echo "7" > debian/compat
592 test -e debian/source/format || echo "3.0 (native)" > debian/source/format
593 test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
594 cd - > /dev/null
595 }
596
597 buildsimplenativepackage() {
598 local NAME="$1"
599 local NM
600 if [ "$(echo "$NAME" | cut -c 1-3)" = 'lib' ]; then
601 NM="$(echo "$NAME" | cut -c 1-4)"
602 else
603 NM="$(echo "$NAME" | cut -c 1)"
604 fi
605 local ARCH="$2"
606 local VERSION="$3"
607 local RELEASE="${4:-unstable}"
608 local DEPENDENCIES="$5"
609 local DESCRIPTION="${6:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
610 If you find such a package installed on your system,
611 something went horribly wrong! They are autogenerated
612 und used only by testcases and surf no other propose…"}"
613
614 local SECTION="${7:-others}"
615 local PRIORITY="${8:-optional}"
616 local FILE_TREE="$9"
617 local COMPRESS_TYPE="${10:-gzip}"
618 local DISTSECTION
619 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
620 DISTSECTION="main"
621 else
622 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
623 fi
624 local BUILDDIR=${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}
625
626 msgtest "Build source package in version ${VERSION} for ${RELEASE} in ${DISTSECTION}" "$NAME"
627 mkdir -p $BUILDDIR/debian/source
628 echo "* most suckless software product ever" > ${BUILDDIR}/FEATURES
629 echo "#!/bin/sh
630 echo '$NAME says \"Hello!\"'" > ${BUILDDIR}/${NAME}
631
632 echo "Copyleft by Joe Sixpack $(date +%Y)" > ${BUILDDIR}/debian/copyright
633 echo "$NAME ($VERSION) $RELEASE; urgency=low
634
635 * Initial release
636
637 -- Joe Sixpack <joe@example.org> $(date -R)" > ${BUILDDIR}/debian/changelog
638 echo "Source: $NAME
639 Priority: $PRIORITY
640 Maintainer: Joe Sixpack <joe@example.org>
641 Standards-Version: 3.9.3" > ${BUILDDIR}/debian/control
642 if [ "$SECTION" != '<none>' ]; then
643 echo "Section: $SECTION" >> ${BUILDDIR}/debian/control
644 fi
645 local BUILDDEPS="$(echo "$DEPENDENCIES" | grep '^Build-')"
646 test -z "$BUILDDEPS" || echo "$BUILDDEPS" >> ${BUILDDIR}/debian/control
647 echo "
648 Package: $NAME" >> ${BUILDDIR}/debian/control
649
650 if [ "$ARCH" = 'all' ]; then
651 echo "Architecture: all" >> ${BUILDDIR}/debian/control
652 else
653 echo "Architecture: any" >> ${BUILDDIR}/debian/control
654 fi
655 local DEPS="$(echo "$DEPENDENCIES" | grep -v '^Build-')"
656 test -z "$DEPS" || echo "$DEPS" >> ${BUILDDIR}/debian/control
657 echo "Description: $DESCRIPTION" >> ${BUILDDIR}/debian/control
658
659 echo '3.0 (native)' > ${BUILDDIR}/debian/source/format
660 cd ${BUILDDIR}/..
661 testsuccess --nomsg dpkg-source -b ${NAME}-${VERSION}
662 cd - >/dev/null
663 sed -n 's#^dpkg-source: info: building [^ ]\+ in ##p' ${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output \
664 | while read SRC; do
665 echo "pool/${SRC}" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.srclist
666 # if expr match "${SRC}" '.*\.dsc' >/dev/null 2>&1; then
667 # aptkey --keyring ./keys/joesixpack.pub --secret-keyring ./keys/joesixpack.sec --quiet --readonly \
668 # adv --yes --default-key 'Joe Sixpack' \
669 # --clearsign -o "${BUILDDIR}/../${SRC}.sign" "${BUILDDIR}/../$SRC"
670 # mv "${BUILDDIR}/../${SRC}.sign" "${BUILDDIR}/../$SRC"
671 # fi
672 done
673
674 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
675 msgtest "Build binary package for ${RELEASE} in ${SECTION}" "$NAME"
676 rm -rf ${BUILDDIR}/debian/tmp
677 mkdir -p ${BUILDDIR}/debian/tmp/DEBIAN ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME} ${BUILDDIR}/debian/tmp/usr/bin
678 cp ${BUILDDIR}/debian/copyright ${BUILDDIR}/debian/changelog ${BUILDDIR}/FEATURES ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}
679 cp ${BUILDDIR}/${NAME} ${BUILDDIR}/debian/tmp/usr/bin/${NAME}-${arch}
680 if [ -n "$FILE_TREE" ]; then
681 cp -ar "$FILE_TREE" ${BUILDDIR}/debian/tmp
682 fi
683
684 (cd ${BUILDDIR}; dpkg-gencontrol -DArchitecture=$arch)
685 (cd ${BUILDDIR}/debian/tmp; md5sum $(find usr/ -type f) > DEBIAN/md5sums)
686 local LOG="${BUILDDIR}/../${NAME}_${VERSION}_${arch}.dpkg-deb.log"
687 # ensure the right permissions as dpkg-deb insists
688 chmod 755 ${BUILDDIR}/debian/tmp/DEBIAN
689 testsuccess --nomsg dpkg-deb -Z${COMPRESS_TYPE} --build ${BUILDDIR}/debian/tmp ${BUILDDIR}/..
690 echo "pool/${NAME}_${VERSION}_${arch}.deb" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.pkglist
691 done
692
693 local CHANGEPATH="${BUILDDIR}/../${DISTSECTION}/${NM}/${NAME}/${NAME}_${VERSION}"
694 mkdir -p $CHANGEPATH
695 cp ${BUILDDIR}/debian/changelog $CHANGEPATH
696 rm -rf "${BUILDDIR}"
697 msgdone "info"
698 }
699
700 buildpackage() {
701 local BUILDDIR=$1
702 local RELEASE=$2
703 local SECTION=$3
704 local ARCH=$(getarchitecture $4)
705 local PKGNAME="$(echo "$BUILDDIR" | grep -o '[^/]*$')"
706 local BUILDLOG="$(readlink -f "${BUILDDIR}/../${PKGNAME}_${RELEASE}_${SECTION}.dpkg-bp.log")"
707 msgtest "Build package for ${RELEASE} in ${SECTION}" "$PKGNAME"
708 cd $BUILDDIR
709 if [ "$ARCH" = "all" ]; then
710 ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
711 fi
712 testsuccess --nomsg dpkg-buildpackage -uc -us -a$ARCH
713 cp ${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output $BUILDLOG
714 local PKGS="$(grep '^dpkg-deb: building package' $BUILDLOG | cut -d'/' -f 2 | sed -e "s#'\.##")"
715 local SRCS="$(grep '^dpkg-source: info: building' $BUILDLOG | grep -o '[a-z0-9._+~-]*$')"
716 cd - > /dev/null
717 for PKG in $PKGS; do
718 echo "pool/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist
719 done
720 for SRC in $SRCS; do
721 echo "pool/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist
722 done
723 }
724
725 buildaptarchive() {
726 if [ -d incoming ]; then
727 buildaptarchivefromincoming "$@"
728 else
729 buildaptarchivefromfiles "$@"
730 fi
731 }
732
733 createaptftparchiveconfig() {
734 local COMPRESSORS="$(cut -d' ' -f 1 ${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf | tr '\n' ' ')"
735 local COMPRESSORS="${COMPRESSORS%* }"
736 local ARCHS="$(getarchitectures)"
737 echo -n 'Dir {
738 ArchiveDir "' >> ftparchive.conf
739 echo -n $(readlink -f .) >> ftparchive.conf
740 echo -n '";
741 CacheDir "' >> ftparchive.conf
742 echo -n $(readlink -f ..) >> ftparchive.conf
743 echo -n '";
744 FileListDir "' >> ftparchive.conf
745 echo -n $(readlink -f pool/) >> ftparchive.conf
746 echo -n '";
747 };
748 Default {
749 Packages::Compress "'"$COMPRESSORS"'";
750 Sources::Compress "'"$COMPRESSORS"'";
751 Contents::Compress "'"$COMPRESSORS"'";
752 Translation::Compress "'"$COMPRESSORS"'";
753 LongDescription "false";
754 };
755 TreeDefault {
756 Directory "pool/";
757 SrcDirectory "pool/";
758 };
759 APT {
760 FTPArchive {
761 Release {
762 Origin "joesixpack";
763 Label "apttestcases";
764 Suite "unstable";
765 Description "repository with dummy packages";
766 Architectures "' >> ftparchive.conf
767 echo -n "$ARCHS" >> ftparchive.conf
768 echo 'source";
769 };
770 };
771 };' >> ftparchive.conf
772 for DIST in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
773 echo -n 'tree "dists/' >> ftparchive.conf
774 echo -n "$DIST" >> ftparchive.conf
775 echo -n '" {
776 Architectures "' >> ftparchive.conf
777 echo -n "$ARCHS" >> ftparchive.conf
778 echo -n 'source";
779 FileList "' >> ftparchive.conf
780 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
781 echo -n '";
782 SourceFileList "' >> ftparchive.conf
783 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
784 echo -n '";
785 Sections "' >> ftparchive.conf
786 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
787 echo '";
788 };' >> ftparchive.conf
789 done
790 }
791
792 buildaptftparchivedirectorystructure() {
793 local DISTS="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
794 for DIST in $DISTS; do
795 local SECTIONS="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
796 for SECTION in $SECTIONS; do
797 local ARCHS="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
798 for ARCH in $ARCHS; do
799 mkdir -p dists/${DIST}/${SECTION}/binary-${ARCH}
800 done
801 mkdir -p dists/${DIST}/${SECTION}/source
802 mkdir -p dists/${DIST}/${SECTION}/i18n
803 done
804 done
805 }
806
807 insertpackage() {
808 local RELEASES="$1"
809 local NAME="$2"
810 local ARCH="$3"
811 local VERSION="$4"
812 local DEPENDENCIES="$5"
813 local PRIORITY="${6:-optional}"
814 local DESCRIPTION="${7:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASES}
815 If you find such a package installed on your system,
816 something went horribly wrong! They are autogenerated
817 und used only by testcases and surf no other propose…"}"
818 local ARCHS=""
819 for RELEASE in $(printf '%s' "$RELEASES" | tr ',' '\n'); do
820 if [ "$RELEASE" = 'installed' ]; then
821 insertinstalledpackage "$2" "$3" "$4" "$5" "$6" "$7"
822 continue
823 fi
824 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
825 if [ "$arch" = 'all' -o "$arch" = 'none' ]; then
826 ARCHS="$(getarchitectures)"
827 else
828 ARCHS="$arch"
829 fi
830 for BUILDARCH in $ARCHS; do
831 local PPATH="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
832 mkdir -p $PPATH
833 local FILE="${PPATH}/Packages"
834 echo "Package: $NAME
835 Priority: $PRIORITY
836 Section: other
837 Installed-Size: 42
838 Maintainer: Joe Sixpack <joe@example.org>" >> $FILE
839 test "$arch" = 'none' || echo "Architecture: $arch" >> $FILE
840 echo "Version: $VERSION
841 Filename: pool/main/${NAME}/${NAME}_${VERSION}_${arch}.deb" >> $FILE
842 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
843 echo "Description: $(printf '%s' "$DESCRIPTION" | head -n 1)" >> $FILE
844 echo "Description-md5: $(printf '%s' "$DESCRIPTION" | md5sum | cut -d' ' -f 1)" >> $FILE
845 echo >> $FILE
846 done
847 done
848 mkdir -p aptarchive/dists/${RELEASE}/main/source aptarchive/dists/${RELEASE}/main/i18n
849 touch aptarchive/dists/${RELEASE}/main/source/Sources
850 echo "Package: $NAME
851 Description-md5: $(printf '%s' "$DESCRIPTION" | md5sum | cut -d' ' -f 1)
852 Description-en: $DESCRIPTION
853 " >> aptarchive/dists/${RELEASE}/main/i18n/Translation-en
854 done
855 }
856
857 insertsource() {
858 local RELEASE="$1"
859 local NAME="$2"
860 local ARCH="$3"
861 local VERSION="$4"
862 local DEPENDENCIES="$5"
863 local BINARY="${6:-$NAME}"
864 local ARCHS=""
865 local SPATH="aptarchive/dists/${RELEASE}/main/source"
866 mkdir -p $SPATH
867 local FILE="${SPATH}/Sources"
868 local DSCFILE="${NAME}_${VERSION}.dsc"
869 local TARFILE="${NAME}_${VERSION}.tar.gz"
870 echo "Package: $NAME
871 Binary: $BINARY
872 Version: $VERSION
873 Maintainer: Joe Sixpack <joe@example.org>
874 Architecture: $ARCH" >> $FILE
875 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
876 echo "Files:
877 $(echo -n "$DSCFILE" | md5sum | cut -d' ' -f 1) $(echo -n "$DSCFILE" | wc -c) $DSCFILE
878 $(echo -n "$TARFILE" | md5sum | cut -d' ' -f 1) $(echo -n "$TARFILE" | wc -c) $TARFILE
879 Checksums-Sha256:
880 $(echo -n "$DSCFILE" | sha256sum | cut -d' ' -f 1) $(echo -n "$DSCFILE" | wc -c) $DSCFILE
881 $(echo -n "$TARFILE" | sha256sum | cut -d' ' -f 1) $(echo -n "$TARFILE" | wc -c) $TARFILE
882 " >> $FILE
883 }
884
885 insertinstalledpackage() {
886 local NAME="$1"
887 local ARCH="$2"
888 local VERSION="$3"
889 local DEPENDENCIES="$4"
890 local PRIORITY="${5:-optional}"
891 local STATUS="${6:-install ok installed}"
892 local DESCRIPTION="${7:-"an autogenerated dummy ${NAME}=${VERSION}/installed
893 If you find such a package installed on your system,
894 something went horribly wrong! They are autogenerated
895 und used only by testcases and surf no other propose…"}"
896
897 local FILE='rootdir/var/lib/dpkg/status'
898 local INFO='rootdir/var/lib/dpkg/info'
899 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
900 echo "Package: $NAME
901 Status: $STATUS
902 Priority: $PRIORITY
903 Section: other
904 Installed-Size: 42
905 Maintainer: Joe Sixpack <joe@example.org>
906 Version: $VERSION" >> $FILE
907 test "$arch" = 'none' || echo "Architecture: $arch" >> $FILE
908 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
909 echo "Description: $DESCRIPTION" >> $FILE
910 echo >> $FILE
911 if [ "$(dpkg-query -W --showformat='${Multi-Arch}')" = 'same' ]; then
912 echo -n > ${INFO}/${NAME}:${arch}.list
913 else
914 echo -n > ${INFO}/${NAME}.list
915 fi
916 done
917 }
918
919
920 buildaptarchivefromincoming() {
921 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
922 cd aptarchive
923 [ -e pool ] || ln -s ../incoming pool
924 [ -e ftparchive.conf ] || createaptftparchiveconfig
925 [ -e dists ] || buildaptftparchivedirectorystructure
926 msgninfo "\tGenerate Packages, Sources and Contents files… "
927 testsuccess aptftparchive generate ftparchive.conf
928 cd - > /dev/null
929 msgdone "info"
930 generatereleasefiles "$@"
931 }
932
933 buildaptarchivefromfiles() {
934 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
935 local DIR='aptarchive'
936 if [ -d "${DIR}/dists" ]; then DIR="${DIR}/dists"; fi
937 find "$DIR" -name 'Packages' -o -name 'Sources' -o -name 'Translation-*' | while read line; do
938 msgninfo "\t${line} file… "
939 compressfile "$line" "$1"
940 msgdone "info"
941 done
942 generatereleasefiles "$@"
943 }
944
945 compressfile() {
946 cat ${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf | while read compressor extension command; do
947 if [ "$compressor" = '.' ]; then
948 if [ -n "$2" ]; then
949 touch -d "$2" "$1"
950 fi
951 continue
952 fi
953 cat "$1" | $command > "${1}.${extension}"
954 if [ -n "$2" ]; then
955 touch -d "$2" "${1}.${extension}"
956 fi
957 done
958 }
959
960 # can be overridden by testcases for their pleasure
961 getcodenamefromsuite() {
962 case "$1" in
963 unstable) echo 'sid';;
964 *) echo -n "$1";;
965 esac
966 }
967 getreleaseversionfromsuite() { true; }
968 getlabelfromsuite() { true; }
969 getoriginfromsuite() { true; }
970
971 generatereleasefiles() {
972 # $1 is the Date header and $2 is the ValidUntil header to be set
973 # both should be given in notation date/touch can understand
974 msgninfo "\tGenerate Release files… "
975 if [ -e aptarchive/dists ]; then
976 for dir in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
977 local SUITE="$(echo "$dir" | cut -d'/' -f 4)"
978 local CODENAME="$(getcodenamefromsuite $SUITE)"
979 local VERSION="$(getreleaseversionfromsuite $SUITE)"
980 local LABEL="$(getlabelfromsuite $SUITE)"
981 local ORIGIN="$(getoriginfromsuite $SUITE)"
982 if [ -n "$VERSION" ]; then
983 VERSION="-o APT::FTPArchive::Release::Version=${VERSION}"
984 fi
985 if [ -n "$LABEL" ]; then
986 LABEL="-o APT::FTPArchive::Release::Label=${LABEL}"
987 fi
988 if [ -n "$ORIGIN" ]; then
989 ORIGIN="-o APT::FTPArchive::Release::Origin=${ORIGIN}"
990 fi
991 aptftparchive -qq release $dir \
992 -o APT::FTPArchive::Release::Suite="${SUITE}" \
993 -o APT::FTPArchive::Release::Codename="${CODENAME}" \
994 ${LABEL} \
995 ${ORIGIN} \
996 ${VERSION} \
997 | sed -e '/0 Release$/ d' > $dir/Release # remove the self reference
998 if [ "$SUITE" = "experimental" -o "$SUITE" = "experimental2" ]; then
999 sed -i '/^Date: / a\
1000 NotAutomatic: yes' $dir/Release
1001 fi
1002 if [ -n "$1" -a "$1" != "now" ]; then
1003 sed -i "s/^Date: .*$/Date: $(date -d "$1" '+%a, %d %b %Y %H:%M:%S %Z')/" $dir/Release
1004 fi
1005 if [ -n "$2" ]; then
1006 sed -i "/^Date: / a\
1007 Valid-Until: $(date -d "$2" '+%a, %d %b %Y %H:%M:%S %Z')" $dir/Release
1008 fi
1009 done
1010 else
1011 aptftparchive -qq release ./aptarchive | sed -e '/0 Release$/ d' > aptarchive/Release # remove the self reference
1012 fi
1013 if [ -n "$1" -a "$1" != "now" ]; then
1014 for release in $(find ./aptarchive -name 'Release'); do
1015 touch -d "$1" $release
1016 done
1017 fi
1018 msgdone "info"
1019 }
1020
1021 setupdistsaptarchive() {
1022 local APTARCHIVE=$(readlink -f ./aptarchive)
1023 rm -f root/etc/apt/sources.list.d/apt-test-*-deb.list
1024 rm -f root/etc/apt/sources.list.d/apt-test-*-deb-src.list
1025 for DISTS in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
1026 SECTIONS=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
1027 msgninfo "\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
1028 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb.list
1029 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb-src.list
1030 msgdone "info"
1031 done
1032 }
1033
1034 setupflataptarchive() {
1035 local APTARCHIVE=$(readlink -f ./aptarchive)
1036 if [ -f ${APTARCHIVE}/Packages ]; then
1037 msgninfo "\tadd deb sources.list line… "
1038 echo "deb file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
1039 msgdone "info"
1040 else
1041 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
1042 fi
1043 if [ -f ${APTARCHIVE}/Sources ]; then
1044 msgninfo "\tadd deb-src sources.list line… "
1045 echo "deb-src file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
1046 msgdone "info"
1047 else
1048 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
1049 fi
1050 }
1051
1052 setupaptarchive() {
1053 local NOUPDATE=0
1054 if [ "$1" = '--no-update' ]; then
1055 NOUPDATE=1
1056 shift
1057 fi
1058 buildaptarchive "$@"
1059 if [ -e aptarchive/dists ]; then
1060 setupdistsaptarchive
1061 else
1062 setupflataptarchive
1063 fi
1064 signreleasefiles 'Joe Sixpack'
1065 if [ "1" != "$NOUPDATE" ]; then
1066 testsuccess aptget update -o Debug::pkgAcquire::Worker=true -o Debug::Acquire::gpgv=true
1067 fi
1068 }
1069
1070 signreleasefiles() {
1071 local SIGNER="${1:-Joe Sixpack}"
1072 local REPODIR="${2:-aptarchive}"
1073 local KEY="keys/$(echo "$SIGNER" | tr 'A-Z' 'a-z' | sed 's# ##g')"
1074 local GPG="aptkey --quiet --keyring ${KEY}.pub --secret-keyring ${KEY}.sec --readonly adv --batch --yes"
1075 msgninfo "\tSign archive with $SIGNER key $KEY… "
1076 local REXKEY='keys/rexexpired'
1077 local SECEXPIREBAK="${REXKEY}.sec.bak"
1078 local PUBEXPIREBAK="${REXKEY}.pub.bak"
1079 if [ "${SIGNER}" = 'Rex Expired' ]; then
1080 # the key is expired, so gpg doesn't allow to sign with and the --faked-system-time
1081 # option doesn't exist anymore (and using faketime would add a new obscure dependency)
1082 # therefore we 'temporary' make the key not expired and restore a backup after signing
1083 cp ${REXKEY}.sec $SECEXPIREBAK
1084 cp ${REXKEY}.pub $PUBEXPIREBAK
1085 local SECUNEXPIRED="${REXKEY}.sec.unexpired"
1086 local PUBUNEXPIRED="${REXKEY}.pub.unexpired"
1087 if [ -f "$SECUNEXPIRED" ] && [ -f "$PUBUNEXPIRED" ]; then
1088 cp $SECUNEXPIRED ${REXKEY}.sec
1089 cp $PUBUNEXPIRED ${REXKEY}.pub
1090 else
1091 if ! printf "expire\n1w\nsave\n" | $GPG --default-key "$SIGNER" --command-fd 0 --edit-key "${SIGNER}" >setexpire.gpg 2>&1; then
1092 cat setexpire.gpg
1093 exit 1
1094 fi
1095 cp ${REXKEY}.sec $SECUNEXPIRED
1096 cp ${REXKEY}.pub $PUBUNEXPIRED
1097 fi
1098 fi
1099 for RELEASE in $(find ${REPODIR}/ -name Release); do
1100 $GPG --default-key "$SIGNER" --armor --detach-sign --sign --output ${RELEASE}.gpg ${RELEASE}
1101 local INRELEASE="$(echo "${RELEASE}" | sed 's#/Release$#/InRelease#')"
1102 $GPG --default-key "$SIGNER" --clearsign --output $INRELEASE $RELEASE
1103 # we might have set a specific date for the Release file, so copy it
1104 touch -d "$(stat --format "%y" ${RELEASE})" ${RELEASE}.gpg ${INRELEASE}
1105 done
1106 if [ -f "$SECEXPIREBAK" ] && [ -f "$PUBEXPIREBAK" ]; then
1107 mv -f $SECEXPIREBAK ${REXKEY}.sec
1108 mv -f $PUBEXPIREBAK ${REXKEY}.pub
1109 fi
1110 msgdone "info"
1111 }
1112
1113 redatereleasefiles() {
1114 local DATE="$(date -d "$1" '+%a, %d %b %Y %H:%M:%S %Z')"
1115 for release in $(find aptarchive/ -name 'Release'); do
1116 sed -i "s/^Date: .*$/Date: ${DATE}/" $release
1117 touch -d "$DATE" $release
1118 done
1119 signreleasefiles "${2:-Joe Sixpack}"
1120 }
1121
1122 webserverconfig() {
1123 local WEBSERVER="${3:-http://localhost:8080}"
1124 local NOCHECK=false
1125 if [ "$1" = '--no-check' ]; then
1126 NOCHECK=true
1127 shift
1128 fi
1129 local DOWNLOG='rootdir/tmp/download-testfile.log'
1130 local STATUS='downloaded/webserverconfig.status'
1131 rm -f "$STATUS" "$DOWNLOG"
1132 local URI
1133 if [ -n "$2" ]; then
1134 msgtest "Set webserver config option '${1}' to" "$2"
1135 URI="${WEBSERVER}/_config/set/${1}/${2}"
1136 else
1137 msgtest 'Clear webserver config option' "${1}"
1138 URI="${WEBSERVER}/_config/clear/${1}"
1139 fi
1140 if downloadfile "$URI" "$STATUS" > "$DOWNLOG"; then
1141 msgpass
1142 else
1143 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/webserverconfig.output"
1144 cat "$DOWNLOG" "$STATUS" >"$OUTPUT" 2>&1 || true
1145 msgfailoutput '' "$OUTPUT"
1146 fi
1147 $NOCHECK || testwebserverlaststatuscode '200'
1148 }
1149
1150 rewritesourceslist() {
1151 local APTARCHIVE="file://$(readlink -f "${TMPWORKINGDIRECTORY}/aptarchive")"
1152 for LIST in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
1153 sed -i $LIST -e "s#$APTARCHIVE#${1}#" -e "s#http://localhost:8080/#${1}#" -e "s#https://localhost:4433/#${1}#"
1154 done
1155 }
1156
1157 # wait for up to 10s for a pid file to appear to avoid possible race
1158 # when a helper is started and dosn't write the PID quick enough
1159 waitforpidfile() {
1160 local PIDFILE="$1"
1161 for i in $(seq 10); do
1162 if test -s "$PIDFILE"; then
1163 return 0
1164 fi
1165 sleep 1
1166 done
1167 msgdie "waiting for $PIDFILE failed"
1168 return 1
1169 }
1170
1171 changetowebserver() {
1172 if [ "$1" != '--no-rewrite' ]; then
1173 rewritesourceslist 'http://localhost:8080/'
1174 else
1175 shift
1176 fi
1177 if test -x ${APTWEBSERVERBINDIR}/aptwebserver; then
1178 cd aptarchive
1179 local LOG="webserver.log"
1180 if ! aptwebserver -o aptwebserver::fork=1 "$@" >$LOG 2>&1 ; then
1181 cat $LOG
1182 false
1183 fi
1184 waitforpidfile aptwebserver.pid
1185 local PID="$(cat aptwebserver.pid)"
1186 if [ -z "$PID" ]; then
1187 msgdie 'Could not fork aptwebserver successfully'
1188 fi
1189 addtrap "kill $PID;"
1190 cd - > /dev/null
1191 else
1192 msgdie 'You have to build aptwerbserver or install a webserver'
1193 fi
1194 }
1195
1196 changetohttpswebserver() {
1197 if ! which stunnel4 >/dev/null; then
1198 msgdie 'You need to install stunnel4 for https testcases'
1199 fi
1200 if [ ! -e "${TMPWORKINGDIRECTORY}/aptarchive/aptwebserver.pid" ]; then
1201 changetowebserver --no-rewrite "$@"
1202 fi
1203 echo "pid = ${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid
1204 cert = ${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem
1205 output = /dev/null
1206
1207 [https]
1208 accept = 4433
1209 connect = 8080
1210 " > ${TMPWORKINGDIRECTORY}/stunnel.conf
1211 stunnel4 "${TMPWORKINGDIRECTORY}/stunnel.conf"
1212 waitforpidfile "${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid"
1213 local PID="$(cat ${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid)"
1214 if [ -z "$PID" ]; then
1215 msgdie 'Could not fork stunnel4 successfully'
1216 fi
1217 addtrap 'prefix' "kill ${PID};"
1218 rewritesourceslist 'https://localhost:4433/'
1219 }
1220
1221 changetocdrom() {
1222 mkdir -p rootdir/media/cdrom/.disk
1223 local CD="$(readlink -f rootdir/media/cdrom)"
1224 echo "acquire::cdrom::mount \"${CD}\";
1225 acquire::cdrom::${CD}/::mount \"mv ${CD}-unmounted ${CD}\";
1226 acquire::cdrom::${CD}/::umount \"mv ${CD} ${CD}-unmounted\";
1227 acquire::cdrom::autodetect 0;" > rootdir/etc/apt/apt.conf.d/00cdrom
1228 echo -n "$1" > ${CD}/.disk/info
1229 if [ ! -d aptarchive/dists ]; then
1230 msgdie 'Flat file archive cdroms can not be created currently'
1231 return 1
1232 fi
1233 mv aptarchive/dists "$CD"
1234 ln -s "$(readlink -f ./incoming)" $CD/pool
1235 find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list' -delete
1236 # start with an unmounted disk
1237 mv "${CD}" "${CD}-unmounted"
1238 # we don't want the disk to be modifiable
1239 addtrap 'prefix' "chmod -f -R +w $PWD/rootdir/media/cdrom/dists/ $PWD/rootdir/media/cdrom-unmounted/dists/ || true;"
1240 chmod -R 555 rootdir/media/cdrom-unmounted/dists
1241 }
1242
1243 downloadfile() {
1244 local PROTO="${1%%:*}"
1245 if ! apthelper -o Debug::Acquire::${PROTO}=1 -o Debug::pkgAcquire::Worker=1 \
1246 download-file "$1" "$2" "$3" 2>&1 ; then
1247 return 1
1248 fi
1249 # only if the file exists the download was successful
1250 if [ -r "$2" ]; then
1251 return 0
1252 else
1253 return 1
1254 fi
1255 }
1256
1257 checkdiff() {
1258 local DIFFTEXT="$(command diff -u "$@" 2>&1 | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
1259 if [ -n "$DIFFTEXT" ]; then
1260 echo >&2
1261 echo >&2 "$DIFFTEXT"
1262 return 1
1263 else
1264 return 0
1265 fi
1266 }
1267
1268 testoutputequal() {
1269 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testoutputequal.output"
1270 local COMPAREFILE="$1"
1271 shift
1272 if "$@" 2>&1 | checkdiff $COMPAREFILE - >"$OUTPUT" 2>&1; then
1273 msgpass
1274 else
1275 echo "=== content of file we compared with (${COMPAREFILE}) ===" >>"${OUTPUT}"
1276 cat "$COMPAREFILE" >>"${OUTPUT}"
1277 msgfailoutput '' "$OUTPUT" "$@"
1278 fi
1279 }
1280
1281 testfileequal() {
1282 msggroup 'testfileequal'
1283 local MSG='Test for correctness of file'
1284 if [ "$1" = '--nomsg' ]; then
1285 MSG=''
1286 shift
1287 fi
1288 local FILE="$1"
1289 shift
1290 if [ -n "$MSG" ]; then
1291 msgtest "$MSG" "$FILE"
1292 fi
1293 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfileequal.output"
1294 if [ -z "$*" ]; then
1295 testoutputequal "$FILE" echo -n ''
1296 else
1297 testoutputequal "$FILE" echo "$*"
1298 fi
1299 msggroup
1300 }
1301
1302 testempty() {
1303 msggroup 'testempty'
1304 msgtest "Test for no output of" "$*"
1305 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testempty.comparefile"
1306 if ("$@" >$COMPAREFILE 2>&1 || true) && test ! -s $COMPAREFILE; then
1307 msgpass
1308 else
1309 msgfailoutput '' "$COMPAREFILE" "$@"
1310 fi
1311 aptautotest 'testempty' "$@"
1312 msggroup
1313 }
1314
1315 testequal() {
1316 msggroup 'testequal'
1317 local MSG='Test of equality of'
1318 if [ "$1" = '--nomsg' ]; then
1319 MSG=''
1320 shift
1321 fi
1322
1323 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequal.comparefile"
1324 echo "$1" > $COMPAREFILE
1325 shift
1326
1327 if [ -n "$MSG" ]; then
1328 msgtest "$MSG" "$*"
1329 fi
1330 testoutputequal "$COMPAREFILE" "$@"
1331 aptautotest 'testequal' "$@"
1332 msggroup
1333 }
1334
1335 testequalor2() {
1336 msggroup 'testequalor2'
1337 local COMPAREFILE1="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile1"
1338 local COMPAREFILE2="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile2"
1339 local COMPAREAGAINST="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.compareagainst"
1340 echo "$1" > $COMPAREFILE1
1341 echo "$2" > $COMPAREFILE2
1342 shift 2
1343 msgtest "Test for equality OR of" "$*"
1344 "$@" >$COMPAREAGAINST 2>&1 || true
1345 if checkdiff $COMPAREFILE1 $COMPAREAGAINST >/dev/null 2>&1 || \
1346 checkdiff $COMPAREFILE2 $COMPAREAGAINST >/dev/null 2>&1
1347 then
1348 msgpass
1349 else
1350 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequal.output"
1351 echo -n "\n${CINFO}Diff against OR 1${CNORMAL}" >"$OUTPUT" 2>&1
1352 checkdiff "$COMPAREFILE1" "$COMPAREAGAINST" >"$OUTPUT" 2>&1 || true
1353 echo -n "${CINFO}Diff against OR 2${CNORMAL}" >"$OUTPUT" 2>&1
1354 checkdiff "$COMPAREFILE2" "$COMPAREAGAINST" >"$OUTPUT" 2>&1 || true
1355 msgfailoutput '' "$OUTPUT"
1356 fi
1357 aptautotest 'testequalor2' "$@"
1358 msggroup
1359 }
1360
1361 testshowvirtual() {
1362 msggroup 'testshowvirtual'
1363 local VIRTUAL="N: Can't select versions from package '$1' as it is purely virtual"
1364 local PACKAGE="$1"
1365 shift
1366 while [ -n "$1" ]; do
1367 VIRTUAL="${VIRTUAL}
1368 N: Can't select versions from package '$1' as it is purely virtual"
1369 PACKAGE="${PACKAGE} $1"
1370 shift
1371 done
1372 msgtest "Test for virtual packages" "apt-cache show $PACKAGE"
1373 VIRTUAL="${VIRTUAL}
1374 N: No packages found"
1375 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testshowvirtual.comparefile"
1376 local ARCH="$(getarchitecture 'native')"
1377 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' >"$COMPAREFILE"
1378 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testshowvirtual.output"
1379 testoutputequal "$COMPAREFILE" aptcache show -q=0 "$PACKAGE"
1380 msggroup
1381 }
1382
1383 testnopackage() {
1384 msggroup 'testnopackage'
1385 msgtest "Test for non-existent packages" "apt-cache show $*"
1386 local SHOWPKG="$(aptcache show "$@" 2>&1 | grep '^Package: ')"
1387 if [ -n "$SHOWPKG" ]; then
1388 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testnopackage.output"
1389 echo "$SHOWPKG" >"$OUTPUT"
1390 msgfailoutput '' "$OUTPUT"
1391 else
1392 msgpass
1393 fi
1394 msggroup
1395 }
1396
1397 testdpkgstatus() {
1398 msggroup 'testdpkgstatus'
1399 local STATE="$1"
1400 local NR="$2"
1401 shift 2
1402 msgtest "Test that $NR package(s) are in state $STATE with" "dpkg -l $*"
1403 local PKGS="$(dpkg -l "$@" 2>/dev/null | grep "^${STATE}" | wc -l)"
1404 if [ "$PKGS" != $NR ]; then
1405 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testnopackage.output"
1406 echo "$PKGS" >"$OUTPUT"
1407 dpkg -l "$@" | grep '^[a-z]' >"$OUTPUT" >&2 || true
1408 msgfailoutput '' "$OUTPUT"
1409 else
1410 msgpass
1411 fi
1412 msggroup
1413 }
1414
1415 testdpkginstalled() {
1416 msggroup 'testdpkginstalled'
1417 testdpkgstatus 'ii' "$#" "$@"
1418 msggroup
1419 }
1420
1421 testdpkgnotinstalled() {
1422 msggroup 'testdpkgnotinstalled'
1423 testdpkgstatus 'ii' '0' "$@"
1424 msggroup
1425 }
1426
1427 testmarkedauto() {
1428 msggroup 'testmarkedauto'
1429 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testmarkedauto.comparefile"
1430 if [ -n "$1" ]; then
1431 msgtest 'Test for correctly marked as auto-installed' "$*"
1432 while [ -n "$1" ]; do echo "$1"; shift; done | sort > $COMPAREFILE
1433 else
1434 msgtest 'Test for correctly marked as auto-installed' 'no package'
1435 echo -n > $COMPAREFILE
1436 fi
1437 testoutputequal "$COMPAREFILE" aptmark showauto
1438 msggroup
1439 }
1440 testmarkedmanual() {
1441 msggroup 'testmarkedmanual'
1442 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testmarkedmanual.comparefile"
1443 if [ -n "$1" ]; then
1444 msgtest 'Test for correctly marked as manually installed' "$*"
1445 while [ -n "$1" ]; do echo "$1"; shift; done | sort > $COMPAREFILE
1446 else
1447 msgtest 'Test for correctly marked as manually installed' 'no package'
1448 echo -n > $COMPAREFILE
1449 fi
1450 testoutputequal "$COMPAREFILE" aptmark showmanual
1451 msggroup
1452 }
1453
1454 msgfailoutput() {
1455 msgreportheader 'msgfailoutput'
1456 local MSG="$1"
1457 local OUTPUT="$2"
1458 shift 2
1459 if [ "$1" = 'grep' ]; then
1460 echo >&2
1461 while [ -n "$2" ]; do shift; done
1462 echo "#### Complete file: $1 ####"
1463 cat >&2 "$1" || true
1464 echo '#### grep output ####'
1465 elif [ "$1" = 'test' ]; then
1466 echo >&2
1467 # doesn't support ! or non-file flags
1468 msgfailoutputstatfile() {
1469 local FILEFLAGS='^-[bcdefgGhkLOprsStuwx]$'
1470 if expr match "$1" "$FILEFLAGS" >/dev/null; then
1471 echo "#### stat(2) of file: $2 ####"
1472 stat "$2" || true
1473 if test -e "$2"; then
1474 echo "#### Complete file: $2 ####"
1475 cat >&2 "$2" || true
1476 fi
1477 fi
1478 }
1479 msgfailoutputstatfile "$2" "$3"
1480 while [ -n "$5" ] && [ "$4" = '-o' -o "$4" = '-a' ]; do
1481 shift 3
1482 msgfailoutputstatfile "$2" "$3"
1483 done
1484 echo '#### test output ####'
1485 fi
1486 cat >&2 $OUTPUT
1487 msgfail "$MSG"
1488 }
1489
1490 testsuccess() {
1491 msggroup 'testsuccess'
1492 if [ "$1" = '--nomsg' ]; then
1493 shift
1494 else
1495 msgtest 'Test for successful execution of' "$*"
1496 fi
1497 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output"
1498 if "$@" >${OUTPUT} 2>&1; then
1499 if expr match "$1" '^apt.*' >/dev/null; then
1500 if grep -q -E ' runtime error: ' "$OUTPUT"; then
1501 msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@"
1502 elif grep -E '^[WE]: ' "$OUTPUT" > "${TMPWORKINGDIRECTORY}/rootdir/tmp/checkforwarnings.output" 2>&1; then
1503 if [ "$IGNORE_PTY_NOT_MOUNTED" = '1' ]; then
1504 if echo 'E: Can not write log (Is /dev/pts mounted?) - posix_openpt (2: No such file or directory)' \
1505 | cmp - "${TMPWORKINGDIRECTORY}/rootdir/tmp/checkforwarnings.output" >/dev/null 2>&1; then
1506 msgpass
1507 else
1508 msgfailoutput 'successful run, but output contains warnings/errors' "$OUTPUT" "$@"
1509 fi
1510 else
1511 msgfailoutput 'successful run, but output contains warnings/errors' "$OUTPUT" "$@"
1512 fi
1513 else
1514 msgpass
1515 fi
1516 else
1517 msgpass
1518 fi
1519 else
1520 local EXITCODE=$?
1521 msgfailoutput "exitcode $EXITCODE" "$OUTPUT" "$@"
1522 fi
1523 aptautotest 'testsuccess' "$@"
1524 msggroup
1525 }
1526 testwarning() {
1527 msggroup 'testwarning'
1528 if [ "$1" = '--nomsg' ]; then
1529 shift
1530 else
1531 msgtest 'Test for successful execution with warnings of' "$*"
1532 fi
1533 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testwarning.output"
1534 if "$@" >${OUTPUT} 2>&1; then
1535 if expr match "$1" '^apt.*' >/dev/null; then
1536 if grep -q -E ' runtime error: ' "$OUTPUT"; then
1537 msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@"
1538 elif grep -q -E '^E: ' "$OUTPUT"; then
1539 msgfailoutput 'successful run, but output contains errors' "$OUTPUT" "$@"
1540 elif ! grep -q -E '^W: ' "$OUTPUT"; then
1541 msgfailoutput 'successful run, but output contains no warnings' "$OUTPUT" "$@"
1542 else
1543 msgpass
1544 fi
1545 else
1546 msgpass
1547 fi
1548 else
1549 local EXITCODE=$?
1550 msgfailoutput "exitcode $EXITCODE" "$OUTPUT" "$@"
1551 fi
1552 aptautotest 'testwarning' "$@"
1553 msggroup
1554 }
1555 testfailure() {
1556 msggroup 'testfailure'
1557 if [ "$1" = '--nomsg' ]; then
1558 shift
1559 else
1560 msgtest 'Test for failure in execution of' "$*"
1561 fi
1562 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output"
1563 if "$@" >${OUTPUT} 2>&1; then
1564 local EXITCODE=$?
1565 msgfailoutput "exitcode $EXITCODE" "$OUTPUT" "$@"
1566 else
1567 local EXITCODE=$?
1568 if expr match "$1" '^apt.*' >/dev/null; then
1569 if [ "$1" = 'aptkey' ]; then
1570 if grep -q -E " Can't check signature: " "$OUTPUT" || \
1571 grep -q -E " BAD signature from " "$OUTPUT"; then
1572 msgpass
1573 else
1574 msgfailoutput "run failed with exitcode ${EXITCODE}, but no signature error" "$OUTPUT" "$@"
1575 fi
1576 else
1577 if grep -q -E ' runtime error: ' "$OUTPUT"; then
1578 msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@"
1579 elif grep -q -E '==ERROR' "$OUTPUT"; then
1580 msgfailoutput 'compiler sanitizers reported errors' "$OUTPUT" "$@"
1581 elif ! grep -q -E '^E: ' "$OUTPUT"; then
1582 msgfailoutput "run failed with exitcode ${EXITCODE}, but with no errors" "$OUTPUT" "$@"
1583 else
1584 msgpass
1585 fi
1586 fi
1587 else
1588 msgpass
1589 fi
1590 fi
1591 aptautotest 'testfailure' "$@"
1592 msggroup
1593 }
1594
1595 testsuccessequal() {
1596 msggroup 'testsuccessequal'
1597 local CMP="$1"
1598 shift
1599 testsuccess "$@"
1600 testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output" "$CMP"
1601 msggroup
1602 }
1603 testwarningequal() {
1604 msggroup 'testwarningequal'
1605 local CMP="$1"
1606 shift
1607 testwarning "$@"
1608 testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/testwarning.output" "$CMP"
1609 msggroup
1610 }
1611 testfailureequal() {
1612 msggroup 'testfailureequal'
1613 local CMP="$1"
1614 shift
1615 testfailure "$@"
1616 testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output" "$CMP"
1617 msggroup
1618 }
1619
1620 testfailuremsg() {
1621 msggroup 'testfailuremsg'
1622 local CMP="$1"
1623 shift
1624 testfailure "$@"
1625 msgtest 'Check that the output of the previous failed command has expected' 'failures and warnings'
1626 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailuremsg.comparefile"
1627 grep '^\(W\|E\):' "${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output" > "$COMPAREFILE" 2>&1 || true
1628 testoutputequal "$COMPAREFILE" echo "$CMP"
1629 msggroup
1630 }
1631
1632 testfilestats() {
1633 msggroup 'testfilestats'
1634 msgtest "Test that file $1 has $2 $3" "$4"
1635 if [ "$4" "$3" "$(stat --format "$2" "$1")" ]; then
1636 msgpass
1637 else
1638 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfilestats.output"
1639 {
1640 ls -ld "$1" || true
1641 echo -n "stat(1) reports for $2: "
1642 stat --format "$2" "$1" || true
1643 } >"$OUTPUT" 2>&1
1644 msgfailoutput '' "$OUTPUT"
1645 fi
1646 msggroup
1647 }
1648 testaccessrights() {
1649 msggroup 'testaccessrights'
1650 testfilestats "$1" '%a' '=' "$2"
1651 msggroup
1652 }
1653
1654 testwebserverlaststatuscode() {
1655 msggroup 'testwebserverlaststatuscode'
1656 local DOWNLOG='rootdir/tmp/webserverstatus-testfile.log'
1657 local STATUS='downloaded/webserverstatus-statusfile.log'
1658 rm -f "$DOWNLOG" "$STATUS"
1659 msgtest 'Test last status code from the webserver was' "$1"
1660 if downloadfile "http://localhost:8080/_config/find/aptwebserver::last-status-code" "$STATUS" > "$DOWNLOG" && [ "$(cat "$STATUS")" = "$1" ]; then
1661 msgpass
1662 else
1663 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testwebserverlaststatuscode.output"
1664 {
1665 if [ -n "$2" ]; then
1666 shift
1667 echo >&2 '#### Additionally provided output files contain:'
1668 cat >&2 "$@"
1669 fi
1670 echo >&2 '#### Download log of the status code:'
1671 cat >&2 "$DOWNLOG"
1672 } >"$OUTPUT" 2>&1
1673 msgfailoutput "Status was $(cat "$STATUS")" "$OUTPUT"
1674 fi
1675 msggroup
1676 }
1677
1678 pause() {
1679 echo "STOPPED execution. Press enter to continue"
1680 local IGNORE
1681 read IGNORE
1682 }
1683
1684 listcurrentlistsdirectory() {
1685 {
1686 find rootdir/var/lib/apt/lists -maxdepth 1 -type d | while read line; do
1687 stat --format '%U:%G:%a:%n' "$line"
1688 done
1689 find rootdir/var/lib/apt/lists -maxdepth 1 \! -type d | while read line; do
1690 stat --format '%U:%G:%a:%s:%y:%n' "$line"
1691 done
1692 } | sort
1693 }
1694
1695 ### convenience hacks ###
1696 mkdir() {
1697 # creating some directories by hand is a tedious task, so make it look simple
1698 if [ "$*" = '-p rootdir/var/lib/apt/lists' ] || [ "$*" = "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists" ] ||
1699 [ "$*" = '-p rootdir/var/lib/apt/lists/partial' ] || [ "$*" = "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial" ]; then
1700 # only the last directory created by mkdir is effected by the -m !
1701 command mkdir -m 755 -p "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt"
1702 command mkdir -m 755 -p "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists"
1703 command mkdir -m 700 -p "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial"
1704 touch "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/lock"
1705 if [ "$(id -u)" = '0' ]; then
1706 chown _apt:root "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial"
1707 fi
1708 else
1709 command mkdir "$@"
1710 fi
1711 }
1712
1713 ### The following tests are run by most test methods automatically to check
1714 ### general things about commands executed without writing the test every time.
1715
1716 aptautotest() {
1717 local TESTCALL="$1"
1718 local CMD="$2"
1719 local FIRSTOPT="$3"
1720 local AUTOTEST="aptautotest_$(basename "$CMD" | tr -d '-')_$(echo "$FIRSTOPT" | tr -d '-')"
1721 if command -v $AUTOTEST >/dev/null; then
1722 shift 3
1723 # save and restore the *.output files from other tests
1724 # as we might otherwise override them in these automatic tests
1725 rm -rf ${TMPWORKINGDIRECTORY}/rootdir/tmp-before
1726 mv ${TMPWORKINGDIRECTORY}/rootdir/tmp ${TMPWORKINGDIRECTORY}/rootdir/tmp-before
1727 mkdir ${TMPWORKINGDIRECTORY}/rootdir/tmp
1728 $AUTOTEST "$TESTCALL" "$@"
1729 rm -rf ${TMPWORKINGDIRECTORY}/rootdir/tmp-aptautotest
1730 mv ${TMPWORKINGDIRECTORY}/rootdir/tmp ${TMPWORKINGDIRECTORY}/rootdir/tmp-aptautotest
1731 mv ${TMPWORKINGDIRECTORY}/rootdir/tmp-before ${TMPWORKINGDIRECTORY}/rootdir/tmp
1732 fi
1733 }
1734
1735 aptautotest_aptget_update() {
1736 local TESTCALL="$1"
1737 while [ -n "$2" ]; do
1738 if [ "$2" = '--print-uris' ]; then return; fi # simulation mode
1739 shift
1740 done
1741 if ! test -d "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists"; then return; fi
1742 testfilestats "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt" '%U:%G:%a' '=' "${TEST_DEFAULT_USER}:${TEST_DEFAULT_GROUP}:755"
1743 testfilestats "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists" '%U:%G:%a' '=' "${TEST_DEFAULT_USER}:${TEST_DEFAULT_GROUP}:755"
1744 # all copied files are properly chmodded
1745 for file in $(find "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists" -type f ! -name 'lock'); do
1746 testfilestats "$file" '%U:%G:%a' '=' "${TEST_DEFAULT_USER}:${TEST_DEFAULT_GROUP}:644"
1747 done
1748 if [ "$TESTCALL" = 'testsuccess' ]; then
1749 # failure cases can retain partial files and such
1750 testempty find "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial" -mindepth 1 ! \( -name 'lock' -o -name '*.FAILED' \)
1751 fi
1752 }
1753 aptautotest_apt_update() { aptautotest_aptget_update "$@"; }
1754 aptautotest_aptcdrom_add() { aptautotest_aptget_update "$@"; }
1755
1756 testaptautotestnodpkgwarning() {
1757 local TESTCALL="$1"
1758 while [ -n "$2" ]; do
1759 if expr match "$2" '^-[a-z]*s' >/dev/null 2>&1; then return; fi # simulation mode
1760 if expr match "$2" '^-dy\?' >/dev/null 2>&1; then return; fi # download-only mode
1761 shift
1762 done
1763 testfailure grep '^dpkg: warning:.*ignor.*' "${TMPWORKINGDIRECTORY}/rootdir/tmp-before/${TESTCALL}.output"
1764 }
1765
1766 aptautotest_aptget_install() { testaptautotestnodpkgwarning "$@"; }
1767 aptautotest_aptget_remove() { testaptautotestnodpkgwarning "$@"; }
1768 aptautotest_aptget_purge() { testaptautotestnodpkgwarning "$@"; }
1769 aptautotest_apt_install() { testaptautotestnodpkgwarning "$@"; }
1770 aptautotest_apt_remove() { testaptautotestnodpkgwarning "$@"; }
1771 aptautotest_apt_purge() { testaptautotestnodpkgwarning "$@"; }